-- function to populate dim_date table. The function 
-- should be called in a cron script to ensure that the
-- desired date is always loaded into the database
CREATE OR REPLACE FUNCTION populate_dim_date(year_limit integer) returns void as $$
DECLARE
	date_iter DATE;
BEGIN
	-- starting date
	SELECT max(dim_date.id) + 1 INTO date_iter FROM dim_date;

	-- if the table was empty
	IF date_iter IS null THEN
		date_iter := TO_DATE(extract(year from CURRENT_DATE) || '-01-01', 'YYYY-MM-DD');
	END IF;

	-- iterating each day
	LOOP
		EXIT WHEN extract(year from date_iter) > year_limit;

		INSERT INTO dim_date values(date_iter, 
					extract(day from date_iter), 
					extract(month from date_iter), 
					extract(year from date_iter)
					);
		date_iter = date_iter + 1;
	END LOOP;
END;
$$ language plpgsql;
