CREATE OR REPLACE FUNCTION load_dim_telecenter() RETURNS void as $$
DECLARE
        tel_row record;
        start_ts TIMESTAMP;
        total_rows INTEGER;
BEGIN
        -- getting initial timestamp
        start_ts = CLOCK_TIMESTAMP();
        total_rows := 0;

	FOR tel_row IN
		SELECT	
			i.tl_name as new_tl_name,
			i.tl_phone as new_tl_phone,
			c.id as new_tl_cit_id,
			i.tl_street as new_tl_street,
			i.tl_numbr as new_tl_numbr,
			i.tl_zipcode as new_tl_zipcode,
			i.tl_neighborhood as new_tl_neighborhood,
			i.tl_geolocation as new_tl_geolocation,
			i.tl_admin_name as new_tl_admin_name,
			i.tl_admin_phone as new_tl_admin_phone,			
			i.m_superid as new_m_superid,
			substring(i.m_superid from 13 for 10) as new_superid,
			current_date as update_date,

			t.id as old_id,
			t.name as old_tl_name,
			t.phone as old_tl_phone,
                        t.cit_id as old_tl_cit_id,
                        t.street as old_tl_street,
                        t.numbr as old_tl_numbr,
                        t.zipcode as old_tl_zipcode,
                        t.neighborhood as old_tl_neighborhood,
                        t.geolocation as old_tl_geolocation,
                        t.admin_name as old_tl_admin_name,
                        t.admin_phone as old_tl_admin_phone,
			t.m_superid as old_m_superid
		FROM telecenter_inventory i 
		INNER JOIN dim_city c ON (i.tl_city = c.name)
		LEFT JOIN dim_telecenter t ON (i.m_superid = t.m_superid)
	LOOP

		IF (tel_row.new_tl_cit_id IS NOT NULL AND tel_row.old_m_superid IS NOT NULL AND (tel_row.new_tl_name != tel_row.old_tl_name OR tel_row.new_tl_phone != tel_row.old_tl_phone
OR tel_row.new_tl_cit_id != tel_row.old_tl_cit_id OR tel_row.new_tl_street != tel_row.old_tl_street OR tel_row.new_tl_numbr != tel_row.old_tl_numbr OR tel_row.new_tl_zipcode != tel_row.old_tl_zipcode OR tel_row.new_tl_neighborhood != tel_row.old_tl_neighborhood OR tel_row.new_tl_geolocation != tel_row.old_tl_geolocation OR tel_row.new_tl_admin_name != tel_row.old_tl_admin_name OR tel_row.new_tl_admin_phone != tel_row.old_tl_admin_phone)) THEN
			INSERT INTO history_dim_telecenter (update_date, tl_id, name, phone, cit_id, m_superid, street, numbr, zipcode, neighborhood, geolocation, admin_name, admin_phone) VALUES (tel_row.update_date, tel_row.old_id, tel_row.old_tl_name, tel_row.new_tl_phone, tel_row.new_tl_cit_id, tel_row.new_m_superid, tel_row.new_tl_street, tel_row.new_tl_numbr, tel_row.new_tl_zipcode, tel_row.new_tl_neighborhood, tel_row.new_tl_geolocation, tel_row.new_tl_admin_name, tel_row.new_tl_admin_phone);
			UPDATE dim_telecenter SET name = tel_row.new_tl_name, phone = tel_row.new_tl_phone, cit_id = tel_row.new_tl_cit_id, street = tel_row.new_tl_street, numbr = tel_row.new_tl_numbr, zipcode = tel_row.new_tl_zipcode, neighborhood = tel_row.new_tl_neighborhood, geolocation = tel_row.new_tl_geolocation, admin_name = tel_row.new_tl_admin_name, admin_phone = tel_row.new_tl_admin_phone WHERE m_superid = tel_row.new_m_superid;
		END IF; 

		IF (tel_row.new_tl_cit_id IS NOT NULL AND tel_row.old_m_superid IS NULL AND tel_row.new_superid = '00000') THEN
			CONTINUE;
		END IF;

		INSERT INTO dim_telecenter (name, phone, cit_id, m_superid, street, numbr, zipcode, neighborhood, geolocation, admin_name, admin_phone) VALUES (tel_row.new_tl_name, tel_row.new_tl_phone, tel_row.new_tl_cit_id, tel_row.new_m_superid, tel_row.new_tl_street, tel_row.new_tl_numbr, tel_row.new_tl_zipcode, tel_row.new_tl_neighborhood, tel_row.new_tl_geolocation, tel_row.new_tl_admin_name, tel_row.new_tl_admin_phone);

		total_rows := total_rows + 1;

	END LOOP;
	
	INSERT INTO control (name, start_time, end_time, total)
		VALUES ('loading dim_telecenter', start_ts, CLOCK_TIMESTAMP(), total_rows);

END;
$$ language plpgsql;
