module.exports = function (grunt) {
    grunt.initConfig({
        less: {
            dev: {
                options: {
                    paths: ["assets/less"]
                },
                files: {
                    'app/css/main.css': 'assets/less/main.less'
                }
            },
            prod: {
                options: {
                    paths: ["assets/less"],
                    yuicompress: true
                },
                files: {
                    'app/css/main.css': 'assets/less/main.less'
                }
            }
        },
        uglify: {
            prod: {
                options: {
                    mangle: false
                },
                files: {
                    'app/js/main.js': [
                        'assets/js/app.js',
                        'assets/js/attendance.js',
                        'assets/js/attendance.search.js',
                        'assets/js/default-charts.js',
                        'assets/js/doc.js',
                        'assets/js/global.js',
                        'assets/js/install.js'
                    ]
                }
            }
        },
        concat: {
            dev: {
                files: {
                    'app/js/main.js': [
                        'assets/js/app.js',
                        'assets/js/attendance.js',
                        'assets/js/attendance.search.js',
                        'assets/js/default-charts.js',
                        'assets/js/doc.js',
                        'assets/js/global.js',
                        'assets/js/install.js'
                    ]
                }
            }
        },
        watch: {
            dev: {
                files: ['assets/**/*'],
                tasks: ['less:dev', 'concat:dev']
            }
        }
    });

    grunt.loadNpmTasks('grunt-contrib-less');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-contrib-concat');
    grunt.loadNpmTasks('grunt-contrib-watch');

    grunt.registerTask('default', ['less:dev', 'concat:dev']);
    grunt.registerTask('prod', ['less:prod', 'uglify:prod']);
};
